Subject: Re: [PATCH] be2net: Adding support for 802.1ad (q-in-q mode)

From: Patrick McHardy <[email-masked]>
Date: Thu, 23 Jul 2009 11:25:53 +0200

Sarveshwar Bandi wrote:
> On 23/07/09 11:07 +0200, Patrick McHardy wrote:
>>> Patch has code to check if the controller is in q-in-q mode. When the packet
>>> has two vids, only the inner vid is passed onto the stack. The stack is never
>>> made aware of the outer vid.
>>
>> But you're still using the outer VLAN group when passing the packet to
>> the VLAN code, so the association to the correct VLAN device can't work.
>
> In the case where packet comes with two vlan ids, the rx descriptor contains
> the inner vlan id and qnq is set to 1, the driver indicates this vid to the
> stack.
> In the case where packet comes with single vlan id, the rx descriptor
> contains the outer vlan id and qnq is set to 0, the driver indicates this
> packet as a non-vlan packet to the stack by calling netif_receive_skb.

I understand that. But the driver does:

	if (vtp) {
		if (!adapter->vlan_grp || adapter->num_vlans == 0) {
			kfree_skb(skb);
			return;
		}
		vid = AMAP_GET_BITS(struct amap_eth_rx_compl, vlan_tag, rxcp);
		vid = be16_to_cpu(vid);
		vlan_hwaccel_receive_skb(skb, adapter->vlan_grp, vid);
	}

adapter->vlan_grp will always be the VLAN group associated directly with
the device, which is the group for the outer tag, not the inner one. So
this can't properly associate packets with the correct VLAN device.